/* ***** BEGIN LICENSE BLOCK *****
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    The Original Code is the Virtual Identity Extension.

    The Initial Developer of the Original Code is Rene Ejury.
    Portions created by the Initial Developer are Copyright (C) 2007
    the Initial Developer. All Rights Reserved.

    Contributor(s): Christian Weiske
 * ***** END LICENSE BLOCK ***** */

/**
* some code copied and adapted from 'display Mail User Agent (MUA)'
* thanks to Christian Weiske <cweiske@cweiske.de>
*/

var vI_getHeader = {
	messenger: null,
	preferences : Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService)
			.getBranch("extensions.virtualIdentity."),
			
	headerParser : Components.classes["@mozilla.org/messenger/headerparser;1"]
				.getService(Components.interfaces.nsIMsgHeaderParser),
				
				
	label: null,
	note_list : new Array(),
	
	strings : document.getElementById("vIdentBundle"),

	noop: function() { return; },
	
	adaptPreferences : function() {
		// this is only for transition from 0.4.0 to 0.4.1, will be removed after a while
		try { 	if (vI_getHeader.preferences.getBoolPref("smart_reply_prefer_headers")) {
				vI_notificationBar.dump("## vI_getHeader: preference-format changed\n## vI_getHeader: appending 'to' and 'cc' to header-list\n")
				vI_getHeader.preferences.setCharPref("smart_reply_headers",
					vI_getHeader.preferences.getCharPref("smart_reply_headers") + "\nto\ncc")
			}
			else {
				vI_notificationBar.dump("## vI_getHeader: preference-format changed\n## vI_getHeader: inserting 'to' and 'cc' to header-list\n")
				vI_getHeader.preferences.setCharPref("smart_reply_headers",
					"to\ncc\n" + vI_getHeader.preferences.getCharPref("smart_reply_headers"))
			}
			vI_getHeader.preferences.clearUserPref("smart_reply_prefer_headers")
			vI_notificationBar.dump("## vI_getHeader: 'smart_reply_prefer_headers' preference-entry removed\n")
		}
		catch(vErr) { }	
	},

	getHeader: function() {
		vI_notificationBar.clear_dump()
		vI_notificationBar.dump("## vI_getHeader: onEndHeaders\n")
		
		vI_getHeader.adaptPreferences();
		
		var srcMsgURI = GetLoadedMessage();
		if (srcMsgURI == null) return;

		var header_list = vI_getHeader.preferences.getCharPref("smart_reply_headers").split(/\n/)
		try { var hdr = vI_getHeader.messenger.messageServiceFromURI(srcMsgURI).messageURIToMsgHdr(srcMsgURI); }
		catch(vErr) {
			vI_notificationBar.dump("## vI_getHeader: can't get Message Header.\n");
			vI_notificationBar.dump("## vI_getHeader: (maybe you're opening a message stored as a file)\n");
			return;
		};

		//loop through the headers
		var found = false;
		var label = vI_getHeader.strings.getString("vident.getHeader.noHeader");
		for (headerName in currentHeaderData) {
			vI_notificationBar.dump("## vI_getHeader: found header: " + headerName + "\n");
			for (index = 0; index < header_list.length; index++) {
				header_to_search_splitted=header_list[index].split(/:/)
				header_to_search=header_to_search_splitted[0]
				if (headerName.toLowerCase() == header_to_search.toLowerCase()) {
					vI_notificationBar.dump("## vI_getHeader: header '" + headerName + "' stored\n");
					value = currentHeaderData[headerName].headerValue;
					hdr.setStringProperty(headerName.toLowerCase(),value);
					if (!found) label = vI_getHeader.strings.getString("vident.getHeader.headerFound");
					label += " " + headerName.toLowerCase()
						+ ":" + value
					found = true;
				}
			}
		}
		vI_notificationBar.setNote(label, "get_header_notification");
	},

	setupEventListener: function() {
		var listener = {};
		listener.onStartHeaders	= vI_getHeader.noop;
		listener.onEndHeaders	= vI_getHeader.getHeader;
		gMessageListeners.push(listener);

		vI_getHeader.messenger = Components.classes["@mozilla.org/messenger;1"].createInstance();
		vI_getHeader.messenger = vI_getHeader.messenger.QueryInterface(Components.interfaces.nsIMessenger);
		vI_getHeader.strings = document.getElementById("vIdentBundle");
	},
}

addEventListener('messagepane-loaded', vI_getHeader.setupEventListener, true);
